       subroutine burg(N, y, M, L, E)
       real y(0:N-1), L(0:M, 0:M), E(0:M)

       parameter(NMAX = 500)
       real ea(0:NMAX-1), eb(0:NMAX-1), num
       integer p

       E(0) = 0
       do 1  i = 0, N-1
             E(0)  =  E(0)  +  y(i) ** 2
             ea(i) = y(i)
             eb(i) = y(i)
1      continue
       E(0) = E(0) / N
       L(0, 0) = 1

       do 2  p = 1, M
             num = 0
             den = 0
             do 3  i = p, N-1
                   num = num + 2 * ea(i) * eb(i-1)
                   den = den + ea(i) ** 2 + eb(i-1) ** 2
3           continue

             gamma = num / den

             E(p) = E(p-1) * (1 - gamma ** 2)

             L(p, p) = 1
             L(p, 0) = - gamma
             do 4  i = 1, p-1
4                  L(p, i) = L(p-1, i-1) - gamma * L(p-1, p-1-i)

             do 5  i = N-1, p, -1
                   temp = ea(i)
                   ea(i) = temp - gamma * eb(i-1)
                   eb(i) = eb(i-1) - gamma * temp
5           continue

2     continue

       return
       end
