c  music.for  -  MUSIC spectrum
c
c      M = filter order
c      E = eigenvector matrix
c      K = dimension of the noise subspace
c     NF = number of frequencies
c     SF = spectrum
c  AF, a = working arrays

       subroutine music(M, E, K, NF, SF, AF, a)
       complex E(0:M, 0:M), a(0:M)
       real SF(0:NF-1), AF(0:NF-1)

       do 1  i = 0, NF-1
1            SF(i) = 0

       do 2  i = 0, K-1
             call select(M, E, i, a)
             call fresp(M, a, NF, AF)
             do 2  j = 0, NF-1
                   SF(j) = SF(j) + AF(j) / K
2      continue

       call invresp(NF, SF)

       return
       end

