       subroutine faest(M, h, x, y, xhat, e, lambda, init)
       real h(0:M), lambda
 
       parameter(MAX = 50, delta = 0.01)
       real w(0:MAX)
       real a(0:MAX), b(0:MAX), k(0:MAX), ktilde(MAX), kbar(0:MAX-1)
       real nu, nutilde, nubar
       save  w, a, b, D1a, D1b, ktilde, nutilde
 
       if (init. eq. 0) then
              do 1  i = 1, M
                    h(i) = 0
                    a(i) = 0
                    b(i-1) = 0
                    w(i) = 0
                    ktilde(i) = 0
1            continue
              D1a = delta
              D1b = delta
              nutilde = 0
              h(0) = 0
              a(0) = 1
              b(M) = 1
              init = 1
       endif
 
       w(0) = y
 
       e0a = 0
       do 2  i = 0, M
2             e0a = e0a + a(i) * w(i)
 
       e1a = e0a / (1 + nutilde)
 
       D0a = lambda * D1a
 
       k(0) = e0a / D0a
 
       D1a =  D0a + e1a * e0a
 
       do 3  i = 1, M
3             k(i) = ktilde(i) + k(0) * a(i)
 
       D0b = lambda * D1b
 
       e0b = k(M) *  D0b
 
       do 4  i = 0, M-1
4         kbar(i) = k(i) - k(M) * b(i)
 
       nu = nutilde + e0a * k(0)
       nubar = nu - e0b * k(M)
 
       e1b = e0b / (1 + nubar)
 
       D1b =  D0b + e1b * e0b
 
       do 5  i = 1, M
5             a(i) = a(i) - e1a * ktilde(i)
 
       do 6  i = 0, M-1
6            b(i) = b(i) - e1b * kbar(i)
 
       xhat0 = 0
       do 7  i = 0, M
7             xhat0 = xhat0 + h(i) * w(i)
 
       e0 = x - xhat0
       e = e0 / (1 + nu)
       xhat = x - e
 
       do 8  i = 0, M
8             h(i) = h(i) + e * k(i)
 
       do 9  i = 1, M
9             ktilde(i) = kbar(i-1)
 
       nutilde = nubar
 
       do 10  i = M, 1, -1
10             w(i) = w(i-1)
 
       return
       end
