c  fresp.for  -  frequency response of a complex polynomial
c  at NF frequency points in the right half of the Nyquist interval

       subroutine fresp(M, a, NF, AF)
       complex a(0:M)
       real AF(0:NF-1)

       complex imag, z, poly

       pi = 4 * atan(1.)

       do 1  i = 0, NF-1
             omega = pi * i / NF
             z = cexp(cmplx(0., -omega))
             AF(i) = cabs( poly(M, a, z) ) ** 2
1      continue

       return
       end
