       subroutine glwf(M,g,gamma,x,y,xhat,e,lambda,beta,init)
       real g(0:M), gamma(M), lambda
 
       parameter (MAX = 50)
       real w(MAX), db(0:MAX), d(MAX)
       real ea(0:MAX), eb(0:MAX)
       integer p
       save w, db, d
 
       if (init. eq. 0) then
            do 1  p = 1, M
                  w(i) = 0
                  g(p) = 0
                  gamma(p) = 0
                  d(p) = 0
                  db(p) = 0
1          continue
            g(0) = 0
            db(0) = 0
       endif
 
       ea(0) = y
       eb(0) = y
       xhat = g(0) * eb(0)
       e = x - xhat
 
       db(0) = lambda * db(0) + eb(0) * eb(0)
       g(0) = g(0) + beta * e * eb(0) / db(0)
 
       do 2  p = 1, M
             ea(p) = ea(p-1) - gamma(p) * w(p)
             eb(p) = w(p) - gamma(p) * ea(p-1)
 
             d(p) = lambda * d(p) + ea(p-1) * ea(p-1) + w(p) * w(p)

             gamma(p)=gamma(p)+beta*(ea(p)*w(p)+eb(p)*ea(p-1))/d(p)
 
             xhat = xhat + g(p) * eb(p)
             e = e - g(p) * eb(p)
 
             db(p) = lambda * db(p) + eb(p) * eb(p)

             if (p .le. init) then
                   g(p) = g(p) + beta * e * eb(p) / db(p)
             endif
 
             w(p) = eb(p-1)
2     continue
 
       init = init + 1
 
       return
       end
